;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                ;;
;; Copyright (C) 2006  Patrik Nilsson                                             ;;
;;                                                                                ;;
;; This program is free software; you can redistribute it and/or modify           ;;
;; it under the terms of the GNU General Public License as published by           ;;
;; the Free Software Foundation; either version 2 of the License, or              ;;
;; (at your option) any later version.                                            ;;
;;                                                                                ;;
;; This program is distributed in the hope that it will be useful,                ;;
;; but WITHOUT ANY WARRANTY; without even the implied warranty of                 ;;
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                  ;;
;; GNU General Public License for more details.                                   ;;
;;                                                                                ;;
;; You should have received a copy of the GNU General Public License              ;;
;; along with this program; if not, write to the Free Software                    ;;
;; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA ;;
;;                                                                                ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Current list of commands: oper, kick, kill, mode, invite, raw

(defun circe-command-OPER (line)
  "Login as a adminstrator of the server."
  (if (not circe-chat-target)
	  (circe-server-message "No target for current buffer")
	(setq line (split-string line " "))
	(setq username (car line))
	(setq password (car (cdr line)))
	(when (not password)
		(circe-server-message "Usage: /OPER <username> <password>"))
	(when password
	  (circe-server-send (format "OPER %s %s" username password)))))

(defun circe-command-KICK (line)
  "bans and then kicks WHO"
  (interactive "sKick: ")
  (if (not circe-chat-target)
      (circe-server-message "No target for current buffer")
	(setq line (split-string line " "))
	(setq who (car line))
	(setq why (cdr line))
	(when (not why)
	  (circe-server-send (format "KICK %s %s" circe-chat-target who)))
	(when why
	  (circe-server-send (format "KICK %s %s :%s" circe-chat-target who why)))))

(defun circe-command-KILL (line)
  "kills a user"
  (interactive "sKill: ")
  (if (not circe-chat-target)
	  (circe-server-message "No target for current buffer")
	(setq line (split-string line " "))
	(setq who (car line))
	(setq why (cdr line))
	(when (not why)
	  (circe-server-message "Usage: /KILL <user> <reson>"))
	(when why
	  (circe-server-send (format "KILL %s :%s" who why)))))

(defun circe-command-MODE (line)
  "Change the mode for a user or a channel."
  (interactive "sMode: ")
  (if (not circe-chat-target)
      (circe-server-message "No target for current buffer")
	(circe-server-send (format "MODE %s %s" circe-chat-target line)
					   (if (string= line "")
						   " "
						 line)))
  (circe-split-line line))

(defun circe-command-INVITE (who)
  "invites a user to current channel"
  (interactive "sWho: ")
  (if (not circe-chat-target)
      (circe-server-message "No target for current buffer")
	(circe-server-send (format "INVITE %s %s" who circe-chat-target)
					   (if (string= who "")
						   " "
						 who)))
  (circe-split-line who))

(defun circe-command-RAW (line)
  "Sends a raw command to the server."
  (interactive "sRaw: ")
  (if (not circe-chat-target)
      (circe-server-message "No target for current buffer")
	(circe-server-send (format "%s" line)
					   (if (string= line "")
						   " "
						 line)))
  (circe-split-line line))